﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Finish : MonoBehaviour {
    private float counter = 2f;
    public int level2Load;
    public Text finishText;
    private Gameinfo gi;
    //variable dinerets per accedir a l'script Dinerets
    private Dinerets dn;

    void Start()
    {
        gi = GameObject.FindWithTag("info").GetComponent<Gameinfo>();
        dn = GameObject.FindWithTag("Dineret").GetComponent<Dinerets>(); //dn accedeix a script Dinerets
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.CompareTag("Player")&& (dn.dinCount < dn.dinTotal)) {
            gi.finishText.text = ("Encara et falten " +(dn.dinTotal-dn.dinCount) +" monedes !!");
            SoundMGT.sm.PlayNo();
           
        }
      if (collision.CompareTag("Player") && (dn.dinCount == dn.dinTotal))
            {
            SoundMGT.sm.PlayFinal();
        }
    }
   private void OnTriggerStay2D(Collider2D collision)
    {
        if (collision.CompareTag("Player")&&(dn.dinCount==dn.dinTotal))
        {
           
            gi.finishText.text = ("Molt bé !!");
           
            counter -= Time.deltaTime;
            Debug.Log("final");
            
        }
       
        


    }
  private void OnTriggerExit2D(Collider2D collision)
    {
        counter = 2f;
        gi.finishText.text = ("");
    }

    private void Update()
    {
        //Debug.Log(counter);
        if (counter <= 0f)
        {
            Application.LoadLevel(level2Load);
        }
    } 
}
