﻿using UnityEngine;
using System.Collections;

public class FollowPlayer : MonoBehaviour
{

    public Transform ThePlayer;
    public Transform TheCow;
    public float moveSpeed = 0.5f;

    private Vida vida;
    private Moviment player;
    public bool hit;
    private float timer;
    public bool Running = true;
    //animacions
    Animator animator;

    void Start()
    {
        vida = GameObject.FindWithTag("Player").GetComponent<Vida>(); //accedir a l'script vida
        player = GameObject.FindWithTag("Player").GetComponent<Moviment>(); //accedir a l'script Moviment
                                                                            //referencies
        animator = GetComponent<Animator>();
    }

    
    // Update is called once per frame
    void FixedUpdate() {
        if (Running)
        {
            
            if (Vector3.Distance(ThePlayer.position, this.transform.position) < 10)
        {
            Vector3 direction = ThePlayer.position - this.transform.position;
            direction.y = 0;
            transform.position += direction.normalized * moveSpeed * Time.deltaTime;
             


                if (direction.magnitude > 5)
            {
                transform.position += direction.normalized * moveSpeed*4 * Time.deltaTime;
                   


                }
        }
            animator.SetBool("running", true);

        }
        if (!Running)
        {
                Vector3 direction = ThePlayer.position - this.transform.position;
                direction.y = 0;
                transform.position += direction.normalized * 0 * Time.deltaTime;
                animator.SetBool("running", false);
            
        }

        if (transform.position.x - ThePlayer.position.x <-0.2)
        {
            transform.localScale = new Vector3(-1, 1, 1);
        }
        if (transform.position.x - ThePlayer.position.x > 0.2)
        {
            transform.localScale = new Vector3(1, 1, 1);
        }
        if (hit)
        {
            timer -= Time.deltaTime;
            if (timer <= 0)
            {
                hit = false;
            }


        }
    }
    //col·lisio cols
    void OnTriggerEnter2D (Collider2D collision)
    {
        if (collision.CompareTag("cols"))
        {
            Destroy(collision.gameObject);
            //Debug.Log("cols");
        }
        if (collision.CompareTag("Player") && !hit)
        {
            vida.Damage(1);

            StartCoroutine(player.Tocat(1f));
            hit = true;
            timer = 0.5f;

        }
    }
}