﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Moviment : MonoBehaviour {
    //variables moviment
    public float velX = 0.03f;
    public float movX;
    public float inputX;
    //public bool moveright;
    //public bool moveleft;
    public bool miraDreta = true;
    //variables salt
    public float salt = 320f;
    public float saltX = 0f;
    public Transform peu;
    public float radiPeu;
    public LayerMask terra;
    public bool aTerra;
    //variables correr
    public bool isRun;
    
    //variables escalar paret
    public bool aParet;
    public Transform paretCheckPoint;
    public float radiCheckPointParet;
    public LayerMask paret;
    //variables caixa
    public bool agafaCaixa;
    public LayerMask caixa;
    //public GameObject Caixa;
    //public GameObject Patufet;
    //public bool caixaTerra;
    //public float radiCheckTerra;
    //public Transform caixaCheck;
    private CaixaCheck cx;
    //variables caiguda
    public bool aCaigut;
    public LayerMask fallDetect;
    //animacions
    Animator animator;
    //variable Rigidbody
    Rigidbody2D rb2d;
    //variable dinerets per accedir a l'script Dinerets
    private Dinerets dn;
   
    void Awake () {    //asignar valors abans de Start
        //referencies
        animator = GetComponent <Animator>();
        rb2d = GetComponent <Rigidbody2D>();
        //dn = GetComponent<Dinerets>();
        dn = GameObject.FindWithTag("Dineret").GetComponent<Dinerets>(); //dn accedeix a script Dinerets
        cx = GameObject.FindWithTag("caixes").GetComponent<CaixaCheck>(); 

    }
   
	// Use this for initialization
	void Start () {
       
    }
	
	// Update is called once per frame
	void FixedUpdate () {
       

            float inputX = Input.GetAxis("Horizontal"); //guarda valor eix X
		
        if (inputX > 0 ) {
            movX = transform.position.x + (inputX * velX);
            transform.position = new Vector3(movX, transform.position.y, 0);
            transform.localScale = new Vector3(1, 1, 1);
            miraDreta = true;
        }
        if (inputX < 0 ) {
            movX = transform.position.x + (inputX * velX);
            transform.position = new Vector3(movX, transform.position.y, 0);
            transform.localScale = new Vector3(-1, 1, 1); //Voltejar en Horitzontal 
            miraDreta = false;
        }

        if (inputX != 0 && aTerra) { 
            animator.SetFloat("velX", 1);
        } else {
            animator.SetFloat("velX", 0);
        }
        //salt
        aTerra = Physics2D.OverlapCircle(peu.position, radiPeu, terra + caixa);
       
        if (aTerra &&  !aParet && Input.GetKeyDown(KeyCode.Space)) {
            //tComponent<Rigidbody2D>().velocity = new Vector2(GetComponent<Rigidbody2D>().velocity.x, 0);
            SoundMGT.sm.PlaySalt();
            GetComponent<Rigidbody2D>().AddForce(new Vector2 (saltX, salt));
           
            animator.SetBool("aTerra", false);
        }
        if (aTerra) {
            animator.SetBool("aTerra", true);
            aParet = false;
            animator.SetBool("aParet", false);

        } else {
            animator.SetBool("aTerra", false);
        }
        //correr
        if (inputX > 0 || inputX < 0) {
            if (Input.GetKey(KeyCode.X) && aTerra) {
                isRun = true;
                salt = 380f;
                saltX = inputX * 100f;
                velX = 0.1f;
                animator.SetBool("isRun", true);
            } else {
                isRun = false;
                velX = 0.03f;
                salt = 320f;
                saltX = 0f;
                animator.SetBool("isRun", false);
            }
        }
       
        //caigut
        if (!aTerra && !aParet)
        {
            aCaigut = Physics2D.OverlapCircle(peu.position, radiPeu, fallDetect);
            animator.SetBool("aParet", false);
            if (aCaigut)
            {
                //Debug.Log("acaigut!");
            }
        }

        //escalar
     
            aParet = Physics2D.OverlapCircle(paretCheckPoint.position, radiCheckPointParet, paret);
           
                if (aParet && !aTerra) {
            
            ParetSliding();
                }
                if (aParet && aTerra )
        {
            
            aTerra = false;
            
            ParetSliding();
        }

        //  }
        //CAIXA
         agafaCaixa = Physics2D.OverlapCircle(paretCheckPoint.position, radiCheckPointParet, caixa);
        //caixaTerra = Physics2D.OverlapCircle(caixaCheck.position, radiCheckTerra, terra);
        if (agafaCaixa)
        {
            if (Input.GetKey(KeyCode.V))
            {
                cx.Caixa.transform.parent = cx.Patufet.transform;
                cx.Caixa.GetComponent<Rigidbody2D>().gravityScale = 0;
                cx.Caixa.GetComponent<Rigidbody2D>().isKinematic = true;

            } else
            {
                cx.Caixa.transform.parent = null;
                cx.Caixa.GetComponent<Rigidbody2D>().gravityScale = 1;
                cx.Caixa.GetComponent<Rigidbody2D>().isKinematic = false;
              if (cx.caixaTerra)
                {
                    cx.Caixa.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static;
                } 
               
            }
        }

      
    } //FI FIXEDUPDATE

   

    //paret sliding
    void ParetSliding()
    {
        rb2d.velocity = new Vector2(rb2d.velocity.x, -0.7f);
        aParet = true;
        animator.SetBool("aParet", true);
        if (Input.GetKeyDown(KeyCode.Space)) {
            if (miraDreta)
            {
                rb2d.AddForce(new Vector2(-0.2f, 1.2f) * salt);
                transform.localScale = new Vector3(-1, 1, 1);
                miraDreta = false;
                animator.SetBool("aParet", false);
            }
            else
            {
                rb2d.AddForce(new Vector2(0.2f,1.2f) * salt);
                transform.localScale = new Vector3(1, 1, 1);
                miraDreta = true;
                animator.SetBool("aParet", false);
            }
        }


    }


    //moviment col·lisió amb cames
    public IEnumerator Tocat(float duration)
    {
        float timer = 0;
        rb2d.velocity = new Vector2(0, 5);
     
        while (duration > timer)
        {
            timer += Time.deltaTime;
            rb2d.transform.localScale = new Vector3(1.2f, 0.3f, 1);
            
        }
        yield return 0;
    }
    //col·lisió monedes

    void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.CompareTag ("dineret")) {
            Destroy (collision.gameObject);
            //Debug.Log("moneda");
            dn.dinCount += 1;
            SoundMGT.sm.PlayDineret ();
            
        }
    }

  
}
