﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SoundMGT : MonoBehaviour {

    public static SoundMGT sm;
    public AudioSource audioStart;
    public AudioSource audioFinal;
    public AudioSource audioDineret;
    public AudioSource audioSalt;
    public AudioSource audioHit;
    public AudioSource audioNo;

    void Awake()
    {
        if (sm == null)
        {
            sm = this;
        }
        else if(sm!=this)
        {
            Destroy(gameObject);
        }
    }

    private void OnDestroy()
    {
        sm = null;
    }
   
    public void PlayStart()
    {
        audioStart.Play();
    }
    public void PlayDineret()
    {
        audioDineret.Play();
    }
    public void PlaySalt()
    {
        audioSalt.Play();
    }
    public void PlayHit()
    {
        audioHit.Play();
    }
    public void PlayFinal()
    {
        audioFinal.Play();
    }
    public void PlayNo()
    {
        audioNo.Play();
    }
}

