﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CamFollow : MonoBehaviour {

    private Vector2 velocity;
    public float smoothTimeY;
    public float smoothTimeX;
    public GameObject player;
    public float centerCamY = 0f;
    //variables marges camera
    public bool marges;
    public Vector3 minCamPosition;
    public Vector3 maxCamPosition;

    // Use this for initialization
    void Start() {
        player = GameObject.FindGameObjectWithTag("Player");
    }

    // Update is called once per frame
    void FixedUpdate() {
        float posX = Mathf.SmoothDamp(transform.position.x, player.transform.position.x, ref velocity.x, smoothTimeX);
        float posY = Mathf.SmoothDamp(transform.position.y, player.transform.position.y, ref velocity.y, smoothTimeY);
        transform.position = new Vector3(posX, (posY + centerCamY), transform.position.z);


        if (marges) {
            transform.position = new Vector3(
               Mathf.Clamp(transform.position.x, minCamPosition.x, maxCamPosition.x),
               Mathf.Clamp(transform.position.y, minCamPosition.y, maxCamPosition.y),
               Mathf.Clamp(transform.position.z, minCamPosition.z, maxCamPosition.z));
        }
    }
}
