﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MovimentNivell3 : MonoBehaviour
{
    //variables moviment
    public float velX = 0.03f;
    public float movX;
    public float inputX;
    //public bool moveright;
    //public bool moveleft;
    public bool miraDreta = true;
    //variables salt
    public float salt = 320f;
    public float saltX = 0f;
    public Transform peu;
    public float radiPeu;
    public LayerMask terra;
    public bool aTerra;
    //variables correr
    public bool isRun;
    private bool keyAlternate;
    private float veloX = 1f;
    private float counter;
    //variables escalar paret
    public bool aParet;
    public Transform paretCheckPoint;
    public float radiCheckPointParet;
    public LayerMask paret;
    //variables caixa
    public bool agafaCaixa;
    public LayerMask caixa;
    //public GameObject Caixa;
    //public GameObject Patufet;
    //public bool caixaTerra;
    //public float radiCheckTerra;
    //public Transform caixaCheck;
    private CaixaCheck cx;
    //variables caiguda
    public bool aCaigut;
    public LayerMask fallDetect;
    //animacions
    Animator animator;
    //variable Rigidbody
    Rigidbody2D rb2d;
    //variable dinerets per accedir a l'script Dinerets
    private Dinerets dn;

    void Awake()
    {    //asignar valors abans de Start
        //referencies
        animator = GetComponent<Animator>();
        rb2d = GetComponent<Rigidbody2D>();
        //dn = GetComponent<Dinerets>();
        dn = GameObject.FindWithTag("Dineret").GetComponent<Dinerets>(); //dn accedeix a script Dinerets
        cx = GameObject.FindWithTag("caixes").GetComponent<CaixaCheck>();

    }

    // Use this for initialization
    void Start()
    {

    }

    // Update is called once per frame
    void FixedUpdate()
    {

        /*
        float inputX = Input.GetAxis("Horizontal"); //guarda valor eix X

        if (inputX > 0)
        {
            movX = transform.position.x + (inputX * velX);
            transform.position = new Vector3(movX, transform.position.y, 0);
            transform.localScale = new Vector3(1, 1, 1);
            miraDreta = true;
        }
        if (inputX < 0)
        {
            movX = transform.position.x + (inputX * velX);
            transform.position = new Vector3(movX, transform.position.y, 0);
            transform.localScale = new Vector3(-1, 1, 1); //Voltejar en Horitzontal 
            miraDreta = false;
        }

        if (inputX != 0 && aTerra)
        {
            animator.SetFloat("velX", 1);
        }
        else
        {
            animator.SetFloat("velX", 0);
        }
        */
        //salt
        aTerra = Physics2D.OverlapCircle(peu.position, radiPeu, terra + caixa);

        if (aTerra && !aParet && Input.GetKeyDown(KeyCode.Space))
        {
            //tComponent<Rigidbody2D>().velocity = new Vector2(GetComponent<Rigidbody2D>().velocity.x, 0);
            SoundMGT.sm.PlaySalt();
            GetComponent<Rigidbody2D>().AddForce(new Vector2(saltX, salt));

            animator.SetBool("aTerra", false);
        }
        if (aTerra)
        {
            animator.SetBool("aTerra", true);
            aParet = false;
            animator.SetBool("aParet", false);

        }
        else
        {
            animator.SetBool("aTerra", false);
        }
        //correr
        if (inputX > 0 || inputX < 0)
        {
            if (Input.GetKey(KeyCode.X) && aTerra)
            {
                isRun = true;
                salt = 380f;
                saltX = inputX * 100f;
                velX = 0.1f;
                animator.SetBool("isRun", true);
            }
            else
            {
                isRun = false;
                velX = 0.03f;
                salt = 320f;
                saltX = 0f;
                animator.SetBool("isRun", false);
            }
        }
        //correr alternant dues tecles
        saltX = veloX * 100f;
        if (Input.GetKeyDown(KeyCode.G) && aTerra && keyAlternate == false)
        {
            counter = 0.5f;
            veloX = veloX + 0.2f;
            movX = transform.position.x + (veloX * 0.1f);
            transform.position = new Vector3(movX, transform.position.y, 0);
            isRun = true;
            keyAlternate = true;
            //salt = 380f;
            
        }
        else if (Input.GetKeyDown(KeyCode.H) && aTerra && keyAlternate == true)
        {
            counter = 0.5f;
            veloX = veloX + 0.2f;
            movX = transform.position.x + (veloX * 0.1f);
            transform.position = new Vector3(movX, transform.position.y, 0);
            isRun = true;
            keyAlternate = false;
            //salt = 380f;
           

        }
        else
        {
            counter -= Time.deltaTime;
        }
        if (counter <= 0f)
        {
            veloX = 0.2f;
        }
        if (veloX > 1)
        {
            veloX = 1;
        }

        if (veloX > 0.5f && aTerra)
        {
            animator.SetFloat("velX", 1);
        }
        else
        {
            animator.SetFloat("velX", 0);
        }
        //Debug.Log("salt: " + saltX);
       
        //caigut
        if (!aTerra && !aParet)
        {
            aCaigut = Physics2D.OverlapCircle(peu.position, radiPeu, fallDetect);
            animator.SetBool("aParet", false);
            if (aCaigut)
            {
                Debug.Log("acaigut!");
            }
        }

      
        //CAIXA
        agafaCaixa = Physics2D.OverlapCircle(paretCheckPoint.position, radiCheckPointParet, caixa);
        //caixaTerra = Physics2D.OverlapCircle(caixaCheck.position, radiCheckTerra, terra);
        if (agafaCaixa)
        {
            if (Input.GetKey(KeyCode.V))
            {
                cx.Caixa.transform.parent = cx.Patufet.transform;
                cx.Caixa.GetComponent<Rigidbody2D>().gravityScale = 0;
                cx.Caixa.GetComponent<Rigidbody2D>().isKinematic = true;

            }
            else
            {
                cx.Caixa.transform.parent = null;
                cx.Caixa.GetComponent<Rigidbody2D>().gravityScale = 1;
                cx.Caixa.GetComponent<Rigidbody2D>().isKinematic = false;
                if (cx.caixaTerra)
                {
                    cx.Caixa.GetComponent<Rigidbody2D>().bodyType = RigidbodyType2D.Static;
                }

            }
        }


    } //FI FIXEDUPDATE

    

    
    //col·lisió monedes
    /*
    void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.CompareTag("dineret"))
        {
            Destroy(collision.gameObject);
            //Debug.Log("moneda");
            dn.dinCount += 1;
            SoundMGT.sm.PlayDineret();

        }
    }

    */
}
